class Interface
{
   var gravWell;
   var FR_BURN_INSIGNA = 360;
   var FR_DEETS_INSIGNA = 180;
   var FR_LOOGIE_INSIGNA = 360;
   var FR_POWER_SPIKE = 180;
   var FR_GRAVITY_WELL = 18;
   var nom = new String();
   var etat = new String();
   var oldEtat = new String();
   var oldDir = new Number();
   var paused = new Boolean();
   var missionCD = new Object();
   var packageTimer = new Object();
   var powerUpCD = new Object();
   var nbPoints = new Number();
   var burnInsigna = new Boolean();
   var nbFrBurnInsigna = new Number();
   var deetsInsigna = new Boolean();
   var nbFrDeetsInsigna = new Number();
   var loogieInsigna = new Boolean();
   var nbFrLoogieInsigna = new Number();
   var powerSpike = new Boolean();
   var nbFrPowerSpike = new Number();
   var gravityWell = new Boolean();
   var nbFrGravityWell = new Number();
   var wasCalled = new Boolean();
   var soundPlayCD30 = new Boolean();
   var soundPlayCD10 = new Boolean();
   var oldArrowDist = new Number();
   var nbFrArrowDist = new Number();
   var TextOverlayInfo = new String();
   var TimeLeft = new Number();
   function Interface(l_nom, l_missionCD, l_packageTimer, l_powerUpCD)
   {
      this.nom = l_nom;
      this.etat = "Idle";
      this.oldEtat = "Idle";
      this.nbPoints = 0;
      this.paused = false;
      this.missionCD = l_missionCD;
      this.soundPlayCD30 = false;
      this.soundPlayCD10 = false;
      this.packageTimer = l_packageTimer;
      this.powerUpCD = l_powerUpCD;
      this.wasCalled = false;
      this.oldArrowDist = 99999;
      this.nbFrArrowDist = 0;
      this.burnInsigna = false;
      this.deetsInsigna = false;
      this.loogieInsigna = false;
      this.powerSpike = false;
      this.gravityWell = false;
      this.nbFrBurnInsigna = 0;
      this.nbFrDeetsInsigna = 0;
      this.nbFrLoogieInsigna = 0;
      this.nbFrPowerSpike = 0;
      this.nbFrGravityWell = 0;
   }
   function UpdateEdFace(l_face)
   {
      _global.C._parent.ScrollMap.Items.Hud.EdFace.gotoAndPlay(l_face);
   }
   function EnterFrame()
   {
      this[this.etat]();
      if(this.burnInsigna)
      {
         this.FrBurnInsigna();
      }
      if(this.deetsInsigna)
      {
         this.FrDeetsInsigna();
      }
      if(this.loogieInsigna)
      {
         this.FrLoogieInsigna();
      }
      if(this.powerSpike)
      {
         this.FrPowerSpike();
      }
      if(this.gravityWell)
      {
         this.FrGravityWell();
      }
   }
   function ActivateBurnInsigna()
   {
      this.burnInsigna = true;
      this.nbFrBurnInsigna = 0;
      this.UpdateEdFace("Happy");
      _global.C[_global.C.G_vehPers].ShowPowerUp("burnInsigna",true);
      for(var _loc3_ in _global.C.G_FireColTab)
      {
         _global.C.G_FireColTab[_loc3_].gotoAndStop(2);
      }
   }
   function ActivateDeetsInsigna()
   {
      this.deetsInsigna = true;
      this.nbFrDeetsInsigna = 0;
      this.missionCD.Pause();
      this.UpdateEdFace("Happy");
      _global.C[_global.C.G_vehPers].ShowPowerUp("deetsInsigna",true);
      _global.C._parent.Overlays.gotoAndPlay("timeFreeze");
   }
   function ActivateGravityWell(l_gravWellMC)
   {
      if(!this.loogieInsigna)
      {
         if(!_global.S.isPlaying("gravityWell"))
         {
            _global.S.PlaySound("gravityWell",50,0);
         }
         this.gravWell = l_gravWellMC;
         this.gravityWell = true;
         this.nbFrGravityWell = 0;
         _global.C[_global.C.G_vehPers].SetPowerUpSpeedFactor(0.3,0.5);
         this.UpdateEdFace("Hangry");
      }
   }
   function ActivateLoogieInsigna()
   {
      this.loogieInsigna = true;
      this.nbFrLoogieInsigna = 0;
      if(this.gravityWell)
      {
         this.gravityWell = false;
         _global.C[_global.C.G_vehPers].UnSetPowerUpSpeedFactor();
      }
      _global.C[_global.C.G_vehPers].ShowPowerUp("loogieInsigna",true);
      this.UpdateEdFace("Happy");
   }
   function ActivatePowerSpike()
   {
      if(!_global.S.isPlaying("powerSpike"))
      {
         _global.S.PlaySound("powerSpike",50,0);
      }
      _global.C[_global.C.G_vehPers].SetPowerUpSpeedFactor(1.6,1.5);
      _global.C[_global.C.G_vehPers].SetSpeed(48);
      this.UpdateEdFace("Happy");
      this.nbFrPowerSpike = 0;
      this.powerSpike = true;
   }
   function DeliveredPackage(l_time, l_timeBonus)
   {
      var _loc3_ = 500;
      _global.C.G_nbPackagesDone = _global.C.G_nbPackagesDone + 1;
      if(l_time <= 10)
      {
         _loc3_ += 1500;
      }
      else if(l_time > 10 && l_time <= 15)
      {
         _loc3_ += 1000;
      }
      else if(l_time > 15 && l_time <= 20)
      {
         _loc3_ += 500;
      }
      this.missionCD.AddTime(l_timeBonus);
      this.UpdatePoints(_loc3_);
      this.UpdateNbPackages();
      if(_global.C.G_nbPackagesDone == _global.C.G_nbPackagesToDo)
      {
         this.MissionCompleted();
      }
      this.UpdateEdFace("Happy");
   }
   function FrBurnInsigna()
   {
      this.nbFrBurnInsigna = this.nbFrBurnInsigna + 1;
      if(this.nbFrBurnInsigna >= this.FR_BURN_INSIGNA)
      {
         this.burnInsigna = false;
         for(var _loc3_ in _global.C.G_FireColTab)
         {
            _loc3_.gotoAndStop(1);
         }
         _global.C[_global.C.G_vehPers].ShowPowerUp("burnInsigna",false);
      }
   }
   function FrDeetsInsigna()
   {
      this.nbFrDeetsInsigna = this.nbFrDeetsInsigna + 1;
      if(this.nbFrDeetsInsigna >= this.FR_DEETS_INSIGNA)
      {
         this.deetsInsigna = false;
         this.missionCD.UnPause();
         _global.C[_global.C.G_vehPers].ShowPowerUp("deetsInsigna",false);
      }
   }
   function FrGravityWell()
   {
      var _loc3_ = _global.C[_global.C.G_vehPers].GetStageCoord();
      this.nbFrGravityWell = this.nbFrGravityWell + 1;
      if(this.nbFrGravityWell >= this.FR_GRAVITY_WELL && !this.gravWell.hitTest(_loc3_.x,_loc3_.y,true))
      {
         this.gravityWell = false;
         _global.C[_global.C.G_vehPers].UnSetPowerUpSpeedFactor();
      }
   }
   function FrLoogieInsigna()
   {
      this.nbFrLoogieInsigna = this.nbFrLoogieInsigna + 1;
      if(this.nbFrLoogieInsigna >= this.FR_LOOGIE_INSIGNA)
      {
         this.loogieInsigna = false;
         _global.C[_global.C.G_vehPers].ShowPowerUp("loogieInsigna",false);
      }
   }
   function FrPowerSpike()
   {
      this.nbFrPowerSpike = this.nbFrPowerSpike + 1;
      if(this.nbFrPowerSpike >= this.FR_POWER_SPIKE)
      {
         this.powerSpike = false;
         _global.C[_global.C.G_vehPers].UnSetPowerUpSpeedFactor();
      }
   }
   function GameOver()
   {
      this.PauseAll();
      this.SetState("Idle");
      this.UpdateEdFace("Hangry");
      _quality = "HIGH";
      _global.C._parent.LooseScreen.gotoAndPlay("Loose");
   }
   function GetName()
   {
      return this.nom;
   }
   function GetNbPoints()
   {
      return this.nbPoints;
   }
   function GetState()
   {
      return this.etat;
   }
   function IniMission(l_missionId)
   {
      switch(_global.C.G_missionId)
      {
         case 1:
            this.nbPoints = 0;
            this.missionCD.StartTimer(150);
            _global.C.G_nbPackagesToDo = 10;
            _global.C.G_nbPackagesDone = 0;
            _global.C[_global.C.G_vanAi].SetMaxFrPlayerSeen(180);
            break;
         case 2:
            this.missionCD.StartTimer(180);
            _global.C.G_nbPackagesToDo = 15;
            _global.C.G_nbPackagesDone = 0;
            _global.C[_global.C.G_vanAi].SetMaxFrPlayerSeen(180);
            break;
         case 3:
            this.missionCD.StartTimer(300);
            _global.C.G_nbPackagesToDo = 20;
            _global.C.G_nbPackagesDone = 0;
            _global.C[_global.C.G_vanAi].SetMaxFrPlayerSeen(180);
            break;
         case 4:
            this.missionCD.StartTimer(740);
            _global.C.G_nbPackagesToDo = 25;
            _global.C.G_nbPackagesDone = 0;
            _global.C[_global.C.G_vanAi].SetMaxFrPlayerSeen(180);
      }
      _global.C[_global.C.G_vanAi].SetState("WaitForRespawn");
      var _loc3_ = 0;
      while(_loc3_ < _global.C.G_DropZoneTab.length)
      {
         _global.C[_global.C.G_DropZoneTab[_loc3_]].picked = false;
         _loc3_ = _loc3_ + 1;
      }
      this.packageStolen(false);
      _global.C[_global.C.G_package].ChooseDropZone();
      _global.C[_global.C.G_miniMap].StartFollow(_global.C[_global.C.G_vehPers]);
      this.UpdateNbLife();
      this.UpdateNbPackages();
      this.SetState("UpdateInterface");
      _global.C[_global.C.G_vehPers].SetSpeed(0);
      _global.C[_global.C.G_vehPers].CenterVehToStartPos();
      this.paused = false;
      this.wasCalled = false;
      this.PauseAll();
   }
   function StartMission()
   {
      _global.C[_global.C.G_vehPers].SetVisible();
      _global.C[_global.C.G_vehPers].SetState("Idle");
      _global.C[_global.C.G_vainAi].SetState("WaitForRespawn");
      _global.C._parent.Overlays.gotoAndPlay("Mission" + _global.C.G_missionId + "GoodLuck");
      this.paused = true;
      this.PauseAll();
   }
   function IsBurnInsigna()
   {
      return this.burnInsigna;
   }
   function IsDeetsInsigna()
   {
      return this.deetsInsigna;
   }
   function IsGravityWell()
   {
      return this.gravityWell;
   }
   function IsLoogieInsigna()
   {
      return this.loogieInsigna;
   }
   function IsPowerSpike()
   {
      return this.powerSpike;
   }
   function LooseLife(l_cause)
   {
      _global.C.G_nbLife--;
      if(_global.C.G_nbLife < 1)
      {
         _global.C._parent.Overlays.gotoAndPlay("MissionFailed");
         _global.S.PlaySound("loose",50,0);
         _global.S.StopSound("countDown10");
         _global.S.StopSound("countDown30");
         _global.S.G_TabSonFade.push(["muzikGame",0,"Out",10]);
      }
      else
      {
         this.UpdateNbLife();
         this.UpdateEdFace("Hangry");
         if(l_cause == "Fall")
         {
            _global.C._parent.Overlays.gotoAndPlay("HurryUp");
            _global.S.PlaySound("hurry",100,0);
         }
      }
   }
   function MissionCompleted()
   {
      if(!this.wasCalled)
      {
         this.wasCalled = true;
         this.PauseAll();
         this.TimeLeft = this.missionCD.GetCurrentTime();
         _global.C._parent.ResultScreen.gotoAndPlay("Mission" + _global.C.G_missionId);
         _global.C.G_missionId = _global.C.G_missionId + 1;
         _global.C[_global.C.G_vanAi].SetState("WaitForRespawn");
         _global.S.PlaySound("levComplete",100,0);
         this.UpdateEdFace("Happy");
      }
   }
   function PauseAll()
   {
      if(!this.paused)
      {
         this.paused = true;
         _global.C[_global.C.G_vanAi].Pause();
         _global.C[_global.C.G_vehPers].Pause();
         _global.C[_global.C.G_van].Pause();
         this.missionCD.Pause();
         this.packageTimer.Pause();
         this.powerUpCD.Pause();
      }
      else
      {
         this.paused = false;
         _global.C[_global.C.G_vanAi].UnPause();
         _global.C[_global.C.G_vehPers].UnPause();
         _global.C[_global.C.G_van].UnPause();
         this.missionCD.UnPause();
         this.packageTimer.UnPause();
         this.powerUpCD.UnPause();
      }
   }
   function SetState(l_newState)
   {
      if(l_newState != undefined && l_newState != this.etat)
      {
         this.oldEtat = this.etat;
         this.etat = l_newState;
      }
   }
   function UpdateInterface()
   {
      this.UpdateMissionCD();
      this.UpdatePackageDir();
   }
   function UpdateMapScreen()
   {
      var _loc5_ = _global.C[_global.C.G_package].AttachedToVan();
      var _loc2_ = _global.C.utils.GetMapZone(_global.C[_global.C[_global.C.G_package].GetDropZone()].GetStageCoord());
      var _loc3_ = _global.C.utils.GetMapZone(_global.C[_global.C.G_vehPers].GetStageCoord());
      var _loc4_ = _global.C.utils.GetMapZone(_global.C[_global.C.G_van].GetStageCoord());
      _global.C._parent.MapScreen.Map.EdDot._x = (_loc3_.x - 1) * 2;
      _global.C._parent.MapScreen.Map.EdDot._y = (_loc3_.y - 1) * 2;
      if(_loc5_)
      {
         _global.C._parent.MapScreen.Map.DropDot._x = -100;
         _global.C._parent.MapScreen.Map.DropDot._y = -100;
         _global.C._parent.MapScreen.Map.VanDot._x = (_loc4_.x - 1) * 2;
         _global.C._parent.MapScreen.Map.VanDot._y = (_loc4_.y - 1) * 2;
      }
      else
      {
         _global.C._parent.MapScreen.Map.DropDot._x = (_loc2_.x - 1) * 2;
         _global.C._parent.MapScreen.Map.DropDot._y = (_loc2_.y - 1) * 2;
         _global.C._parent.MapScreen.Map.VanDot._x = -100;
         _global.C._parent.MapScreen.Map.VanDot._y = -100;
      }
   }
   function UpdateMissionCD()
   {
      var _loc3_ = this.missionCD.GetCurrentTime();
      if(_loc3_ < 30)
      {
         if(_global.C._parent.ScrollMap.Items.Hud.timerMC._currentframe == 1)
         {
            _global.C._parent.ScrollMap.Items.Hud.timerMC.gotoAndPlay("flash");
            if(!this.soundPlayCD30)
            {
               _global.C._parent.Overlays.gotoAndPlay("HurryUp");
               _global.S.PlaySound("countDown30",50,100);
               this.soundPlayCD30 = true;
            }
         }
         if(_loc3_ < 10)
         {
            if(!this.soundPlayCD10)
            {
               _global.S.PlaySound("countDown10",50,100);
               _global.S.StopSound("countDown30");
               _global.C._parent.Overlays.gotoAndPlay("HurryUp");
               this.soundPlayCD10 = true;
            }
         }
      }
      else if(_global.C._parent.ScrollMap.Items.Hud.timerMC._currentframe != 1)
      {
         _global.C._parent.ScrollMap.Items.Hud.timerMC.gotoAndPlay("idle");
      }
      if(_loc3_ != null)
      {
         if(_loc3_ >= 60)
         {
            var _loc4_ = Math.floor(_loc3_ / 60);
            var _loc5_ = _loc3_ - _loc4_ * 60;
            if(_loc5_ < 10)
            {
               var _loc6_ = "00:0" + _loc4_ + ":0" + _loc5_;
            }
            else
            {
               _loc6_ = "00:0" + _loc4_ + ":" + _loc5_;
            }
         }
         else if(_loc3_ < 10)
         {
            _loc6_ = "00:00:0" + _loc3_;
         }
         else
         {
            _loc6_ = "00:00:" + _loc3_;
         }
         _global.C._parent.ScrollMap.Items.Hud.timerMC.time_txt.text = _loc6_;
      }
      else
      {
         _global.S.G_TabSonFade.push(["muzikGame",0,"Out",10]);
         _global.S.StopSound("countDown10");
         _global.S.PlaySound("loose",50,0);
         this.GameOver();
      }
   }
   function UpdateNbLife()
   {
      _global.C._parent.ScrollMap.Items.Hud.NbLife_txt.text = _global.C.G_nbLife;
   }
   function UpdateNbPackages()
   {
      _global.C._parent.ScrollMap.Items.Hud.NbPackages_txt.text = _global.C.G_nbPackagesDone + " / " + _global.C.G_nbPackagesToDo;
   }
   function packageStolen(l_stolen)
   {
      _global.C._parent.ScrollMap.Items.Hud.packageStolen._visible = l_stolen;
   }
   function UpdatePackageDir()
   {
      var _loc6_ = _global.C[_global.C.G_package].GetAttachedTo();
      var _loc4_ = new Number();
      var _loc7_ = _global.C[_loc6_].GetStageCoord();
      var _loc3_ = _global.C[_global.C.G_vehPers].GetStageCoord();
      _loc3_.x -= _loc7_.x;
      _loc3_.y -= _loc7_.y;
      _loc4_ = Math.floor(Math.atan2(_loc3_.y,_loc3_.x) * 57.29577951308232) - 90;
      if(_loc4_ != this.oldDir)
      {
         _global.C._parent.ScrollMap.Items.Hud_Fleche._rotation = _loc4_;
         this.oldDir = _loc4_;
      }
      this.nbFrArrowDist = this.nbFrArrowDist + 1;
      if(this.nbFrArrowDist >= 10)
      {
         this.nbFrArrowDist = 0;
         var _loc5_ = _global.C.utils.GetAbsDistBetweenObj(_global.C[_global.C.G_vehPers],_global.C[_loc6_]);
         if(_loc5_ <= 1000)
         {
            if(this.oldArrowDist > 1000)
            {
               _global.C._parent.ScrollMap.Items.Hud_Fleche.Etat.gotoAndPlay("MtoN");
            }
         }
         else if(_loc5_ > 1000 && _loc5_ <= 3000)
         {
            if(this.oldArrowDist <= 1000)
            {
               _global.C._parent.ScrollMap.Items.Hud_Fleche.Etat.gotoAndPlay("NtoM");
            }
            else if(this.oldArrowDist > 3000)
            {
               _global.C._parent.ScrollMap.Items.Hud_Fleche.Etat.gotoAndPlay("FtoM");
            }
         }
         else if(this.oldArrowDist > 1000 && this.oldArrowDist <= 3000)
         {
            _global.C._parent.ScrollMap.Items.Hud_Fleche.Etat.gotoAndPlay("MtoF");
         }
         else if(this.oldArrowDist <= 1000)
         {
            _global.C._parent.ScrollMap.Items.Hud_Fleche.Etat.gotoAndPlay("NtoF");
         }
         else if(_global.C._parent.ScrollMap.Items.Hud_Fleche.Etat._currentframe < 40)
         {
            _global.C._parent.ScrollMap.Items.Hud_Fleche.Etat.gotoAndPlay("NtoF");
         }
         this.oldArrowDist = _loc5_;
      }
   }
   function UpdatePoints(l_points)
   {
      this.nbPoints += l_points;
      _global.C._parent.ScrollMap.Items.Hud.points_txt.text = this.nbPoints;
   }
}
